#include <stdio.h>
#include <stdlib.h>
//#include <string>
#include <iostream>
#include <fstream>
//using namespace std;

#include "MyClassA.h"

//______________________________________________________________________________
MyClassA::MyClassA()
{
//   cout << "---MyClassA::MyClassA()---------" << endl;
   printf("---MyClassA::MyClassA()---------\n");
}

//______________________________________________________________________________
MyClassA::~MyClassA()
{
//   cout << "---MyClassA::~MyClassA()---------" << endl;
   printf("---MyClassA::~MyClassA()---------\n");
}

//______________________________________________________________________________
int MyClassA::TestMultiply(int n, int m)
{
//   cout << "------MyClassA::TestMultiply------" << endl;
   printf("---MyClassA::TestMultiply---------\n");

   printf("printf: n * m = %d\n", n*m);
   std::cout << "cout:   " << n << " * " << m << " = " << n*m << std::endl;
   return (n * m);
}

//______________________________________________________________________________
void MyClassA::TestC(const char *name)
{
//   cout << "------MyClassA::TestC------" << endl;
   printf("---MyClassA::TestC---------\n");

   const char *str = "char_string";
   printf("str = %s\n", str);

//   fString = name;
   printf("MyClassA: fString = %s\n", name);
}

//______________________________________________________________________________
void MyClassA::TestCpp(const char *name)
{
//   cout << "------MyClassA::TestCpp------" << endl;
   printf("---MyClassA::TestCpp---------\n");

   const char *str = "char_string";
//   cout << "  str = " << str << endl;
   std::cout << "  str = " << str << std::endl;

//   fString = name;
//   cout << "  MyClassA: fString = " << name << endl;
   std::cout << "  MyClassA: fString = " << name << std::endl;
}

//______________________________________________________________________________
void MyClassA::WriteFileC(const char *outfile)
{
//   cout << "------MyClassA::WriteFileC------" << endl;
   printf("---MyClassA::WriteFileC---------\n");

   FILE *output;
   output = fopen(outfile, "w");
   if (!output) {
      printf("Error: Could not create output <%s>\n", outfile);
      return;
   }//if

   const char *sep = "\t";
   // output header
   fprintf(output, "TitleC_0");
   for (int k=1; k<4; k++) {
      fprintf(output, sep);
      fprintf(output, "TitleC_%d", k);
   }//for_k
   fprintf(output, "\n");

   // loop over data
   const int nentries = 20;
   for (int i=0; i<nentries; i++) {
      for (int k=0; k<4; k++) {
         if (k != 0) {fprintf(output, sep);}
         float data = static_cast<float>(k*i);
         fprintf(output, "%f", data);
      }//for_j
      fprintf(output, "\n");
   }//for_i
   fclose(output);

   printf("<%d> records exported.\n", nentries);
}

//______________________________________________________________________________
void MyClassA::WriteFileCpp(const char *outfile)
{
//   cout << "------MyClassA::WriteFileCpp------" << endl;
   printf("---MyClassA::WriteFileCpp---------\n");
//   std::cout << "------MyClassA::WriteFileCpp------" << endl;

   std::ofstream output(outfile);
//   ofstream output(outfile);
   if (!output) {
//      cerr << "Error: Could not create output <" << outfile << ">" << endl;
      printf("Error: Could not create output <%s>\n", outfile);
      return;
   }//if

//string s("str21");
//output << s << endl;

   const char *sep = "\t";
   // output header
   output << "TitleCpp_0";
   for (int k=1; k<4; k++) {
      output << sep
             << "TitleCpp_" << k;
   }//for_k
   output << std::endl;
//   output << endl;

   // loop over data
   const int nentries = 20;
   for (int i=0; i<nentries; i++) {
      for (int k=0; k<4; k++) {
         if (k != 0) {output << sep;}
         float data = static_cast<float>(k*i);
         output << data;
//?         output << fixed << data;
      }//for_j
      output << std::endl;
//      output << endl;
   }//for_i

   output.close();

//   cout << "<" << nentries << "> records exported." << endl;
//   printf("<%d> records exported.\n", nentries);
}

